﻿using System.Collections.Generic;

namespace TemporalSourceCover
{
    internal sealed class TemporalGraphEdgeComparer : IComparer<TemporalGraphEdge>
    {
        public int Compare(TemporalGraphEdge? x, TemporalGraphEdge? y)
        {
            if (x is null)
            {
                return y is null ? 0 : 1;
            }
            if (y is null)
            {
                return -1;
            }

            var comp = x.Time.CompareTo(y.Time);
            if (comp != 0)
                return comp;

            comp = x.From.Id.CompareTo(y.From.Id);
            if (comp != 0)
                return comp;

            comp = x.To.Id.CompareTo(y.To.Id);
            if (comp != 0)
                return comp;

            return 0;
        }
    }
}
