﻿using System;
using System.Threading;
using System.Threading.Tasks;

namespace TemporalSourceCover.Utility
{
    public static class Timeout
    {
        private static CancellationToken _token = new CancellationToken(false);

        public static void SetTimeout(TimeSpan timeout)
        {
            _token = new CancellationTokenSource(timeout).Token;
        }

        public static void Disable()
        {
            _token = new CancellationToken(false);
        }

        public static void ThrowOnCancel()
        {
            if (_token.IsCancellationRequested)
                throw new TaskCanceledException();
        }
    }
}
